### `include/elemental/blas-like/level3/`

The level-3 BLAS-like routines implemented in this folder are:

-  `Gemm/`: supporting routines for GEneral Matrix/Matrix multiplication (GEMM)
-  `Gemm.hpp`: interface for GEMM
-  `Hemm.hpp`: HErmitian Matrix/Matrix multiplication (HEMM)
-  `Her2k.hpp`: HErmitian Rank-2k update (HER2K)
-  `Herk.hpp`: HErmitian Rank-k update (HERK)
-  `Symm/`: supporting routines for SYmmetric Matrix/Matrix multiplication 
   (SYMM)
-  `Symm.hpp`: interface for SYMM
-  `Syr2k/`: supporting routines for SYmmetric Rank-2k update (SYR2K)
-  `Syr2k.hpp`: interface for SYR2K
-  `Syrk/`: supporting routines for SYmmetric Rank-k update (SYRK)
-  `Syrk.hpp`: interface for SYRK
-  `Trdtrmm/`: supporting routiens for TRiangular/Diagonal/TRiangular Matrix 
   Multiplication (TRDTRMM)
-  `Trdtrmm.hpp`: interface for TRDTRMM
-  `Trmm/`: supporting routines for TRiangular Matrix Multiplication (TRMM)
-  `Trmm.hpp`: interface for TRMM
-  `Trsm/`: supporting routines for TRiangular Solve of Matrix (TRSM)
-  `Trsm.hpp`: interface for TRSM
-  `Trtrmm/`: supporting routines for TRiangular TRiangular Matrix 
   Multiplication (TRTRMM)
-  `Trtrmm.hpp`: interface for TRTRMM
-  `Trstrm/`: supporting routines for TRiangular Solve against TRiangular Matrix
   (TRSTRM)
-  `Trstrm.hpp`: interface for TRSTRM
-  `TwoSidedTrmm/`: supporting routines for overwriting a Hermitian matrix with
   its congruence relative to a given triangular matrix
-  `TwoSidedTrmm.hpp`: interface for `TwoSidedTrmm`
-  `TwoSidedTrsm/`: supporting routines for overwriting a Hermitian matrix with
   its congruence relative to the inverse of a given triangular matrix
-  `TwoSidedTrsm.hpp`: interface for `TwoSidedTrsm`
